{ =========================================================================== }
{                                 EQDEMO.PAS                                  }
{ =========================================================================== }

{$E+,N+,R+,S+,B-,V-}

program EqDemo;

{ ---> Resolucao de equacoes algebricas                                       }

uses
  Crt, Dos, Equacao;

var
  p, q: polinomio;
  opcao, i, xpos, ypos: byte;
  resposta: solucoes;
  cod, sinal: integer;
  op1, op2: string;
  opcao1, opcao2: char;
  teste: array[1..GrauMax] of char;
  SolInversa: complexo;
  modulo: real;
  h1, h2, min1, min2, s1, s2, decs1, decs2: word;

const
  barra =  '-----------------------------------------------------------------';
  erro: real = 1E-10;
  mens: array[1..17] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  EQDEMO opcao1 opcao2                     ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  opcao1 = 0 ou 1                                     ',
   '                                                                      ',
   '                  opcao2 = T se os coeficientes entrarem pelo tecla-  ',
   '                           do                                         ',
   '                                                                      ',
   '                  opcao2 = A se os coeficientes da equacao fores ge-  ',
   '                           rados aleatoriamente                       ',
   '                                                                      ',
   '             Exemplo  EQDEMO 0 A                                     ',
   '                                                                      ',
   '          ');

begin
  if (ParamCount > 0) then
  begin
    op1 := ParamStr(1);
    op2 := ParamStr(2);
  end;
  if (ParamCount >= 1) then opcao1 := UpCase(op1[1]) else opcao1 := ' ';
  if (ParamCount >= 2) then opcao2 := UpCase(op2[1]) else opcao2 := ' ';
  if (ParamCount = 0) or ((opcao1 <> '0') and (opcao1 <> '1')) then
  begin
    ClrScr; Writeln(#7);
    for i := 1 to 17 do Writeln(mens[i]);
    Writeln; Halt;
  end;
  Val(opcao1, opcao, cod);
  if (cod <> 0) then Halt;
  repeat
    ClrScr;
    Write('Grau da equacao (de 2 a ', GrauMax, ' )  = '); Readln(p.grau);
    Writeln;
    if (opcao2 <>  'A') then
    begin
      Write('Forneca os coeficientes da equacao segundo as potencias ');
      Writeln('decrescentes de ''x'' : '); Writeln;
      for i := p.grau downto 0 do Read(p.coef[i]);
    end
    else
    begin
      Randomize; Write('Coeficientes da equacao segundo as potencias ');
      Writeln(' decrescentes de ''x'' : '); Writeln;
      for i := p.grau downto 0 do
      begin
        sinal := Random(10);
        if Odd(sinal) then sinal := -1 else sinal := 1;
        p.coef[i] := sinal*Random(100);
        Write(Round(p.coef[i]), '  ');
      end;
      Writeln;
    end;
    Writeln;
    GetTime(h1, min1, s1, decs1);

    ResolveEquacao(p, opcao, resposta);

    GetTime(h2, min2, s2, decs2);
    if (not resposta.resolveu) then
    begin
      Writeln('Nao foi possivel resolver a equacao');
      Halt;
    end;
    q.grau := p.grau;
    for i := 0 to p.grau do
      q.coef[i] := p.coef[p.grau - i];
    for i := 1 to p.grau do
      if (Fz(p, resposta.x[i].Re, resposta.x[i].Im) < erro) then
        teste[i] := 'C'
      else
      begin
        if (resposta.x[i].Im = 0) then
        begin
          SolInversa.Im := 0;
          SolInversa.Re := 1/resposta.x[i].Re;
        end
        else
        begin
          modulo := Sqr(resposta.x[i].Re) + Sqr(resposta.x[i].Im);
          SolInversa.Im := -resposta.x[i].Im/modulo;
          SolInversa.Re := resposta.x[i].Re/modulo;
        end;
        if (Fz(q, SolInversa.Re, SolInversa.Im) < erro) then
          teste[i] := 'I'
        else
          teste[i] := 'E';
      end;
    Writeln('Solucao:');
    Writeln; Writeln(barra);
    Writeln('   #         parte real       parte imaginaria   teste',
                                                                '   metodo  ');
    Writeln(barra);
    for i := 1 to p.grau do
      Writeln(i:4, resposta.x[i].Re:20:10, resposta.x[i].Im:20:10, '       ',
                                      teste[i], '     ', resposta.x[i].metodo);
    Writeln(barra);
    Writeln; xpos := WhereX; ypos := WhereY;
    Write('Pressione [ENTER] para continuar ');
    Delay(1500); GoToXY(xpos, ypos);
    Write('   Inicio ''as ', h1:2, ':', min1:2, ':', s1:2, ':', decs1:2,
          '                  ',
          'Fim ''as ', h2:2, ':', min2:2, ':', s2:2, ':', decs2:2, '  ');
    Readln; Readln;
  until (1 > 2);
end.

{ =========================================================================== }

