{ =========================================================================== }
{                                 JANELAS.PAS                                 }
{ =========================================================================== }

unit Janelas;

{$E+,N+,F+,R+,V-,B-,S+}

{ ---> Controla a apresentacao das molduras e menus usados por ALC.PAS        }

interface

uses
  FPTCBas;

procedure MenuPrincipal(tela1, tela2, tela3, tela4: TelaPtr;
                                        mat: MatPtr; ind1, ind2, ind3: IndPtr);

{ =========================================================================== }

implementation

uses
  Crt, Printer, Matrizes, Equacao, AlgLin, Jordan;

var
  ind: MIndice;

const
  LarguraImpPapel: byte = 80;

{ --------------------------------------------------------------------------- }

procedure MostraNulDet(mat: matriz; imp: InfoPress; var sair: boolean;
                   var ja: MatLogica; var nulid: byte; var determinante: real);

var
  tam1, tam2, tam3, tam4: byte;
  ch: char;
  HouveErro, voltar: boolean;
  TelaAux: TelaPtr;

begin
  New(TelaAux);
  voltar := false; imp.racional := 0;
  if (not ja.calc[0]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o determinante...                                ');
    determinante := Det(mat);
    GoToXY(1, 1);
    Write(' Calculando a nulidade...                                    ');
    nulid := Nul(mat);
    GoToXY(1, 1); Write(mens2[0, 2]);
    ja.calc[0] := true;
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  FormataElemento(nulid, tam1, tam2);
  FormataElemento(determinante, tam3, tam4);
  repeat
    if (imp.racional = 1) then
    begin
      ClrScr;
      ReformataElemento(nulid, tam1, tam2);
      ReformataElemento(determinante, tam3, tam4);
    end;
    GoToXY(13, 3); Write('Nulidade de M = ');
    if (imp.racional = 1) then
      Write(Rac(nulid, tam1, tam2))
    else
      Write(nulid:tam1);
    GoToXY(13, 5); Write('Determinante de M = ');
    if (imp.racional = 1) then
      Write(Rac(determinante, tam3, tam4))
    else
      Write(determinante:tam3:tam4);
    ch := ReadKey;
    HouveErro := false;
    if (ch = #0) then
    begin
      ch := ReadKey;
      case ch of
        F3 : begin
               voltar := true;
               sair := true;
             end;
        F4 : imp.racional := 1;
        F5 : begin
               SalvaTela(TelaAux);
               Termina(27, 16, 7, TelaAux, ind);
             end;
        F7 : voltar := true;
        AltL : Writeln(Lst);
        AltP,
        AltI : begin
                 imp.tela := 0; imp.largura := LarguraImpPapel;
                 if (not ja.imprimiu[11]) then
                 begin
                   Mens(' MATRIZ M ', imp);
                   Writeln(Lst);
                   MostraMatriz(mat, imp);
                   Writeln(Lst);
                   ja.imprimiu[11] := true;
                 end;
                 if (not ja.imprimiu[0]) then
                 begin
                   Mens(' NULIDADE/DETERMINANTE ', imp);
                   Writeln(Lst);
                   Write(Lst, ' ':((imp.largura - 30) div 2),'Nulidade de M = ');
                   if (imp.racional = 1) then
                     Writeln(Lst, Rac(nulid, tam1, tam2))
                   else
                     Writeln(Lst, nulid:tam1);
                   Write(Lst, ' ':((imp.largura - 30) div 2),
                                                       'Determinante de M = ');
                   if (imp.racional = 1) then
                     Writeln(Lst, Rac(determinante, tam3, tam4))
                   else
                     Writeln(Lst, determinante:tam3:tam4);
                   Writeln(Lst);
                   ja.imprimiu[0] := true;
                 end;
                 imp.tela := 1; imp.largura := 56;
               end;
      end;
    end;
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatInv(var mat: matriz; imp: InfoPress; var sair,
     trocou: boolean; var ja: MatLogica; var MatInv: matriz; var inv: boolean);

var
  i, tam1, tam2: byte;
  HouveErro, voltar: boolean;
  ch: char;
  nome: string[20];
  TelaAux: TelaPtr;

begin
  New(TelaAux);
  voltar := false; trocou := false; imp.racional := 0;
  if (not ja.calc[1]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando a matriz inversa...                              ');
    MatInv := mat;
    InverteMatriz(MatInv, inv);
    GoToXY(1, 1); Write(mens2[1, 2]);
    ja.calc[1] := true;
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  if (not inv) then
  begin
    Writeln; Writeln; Writeln;
    Write('               A MATRIZ NAO POSSUI INVERSA');
    ch := ReadKey;
    Exit;
  end;
  MostraMatriz(MatInv, imp);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela(22, 21, ' Nome da matriz? ', nome);
             for i := 1 to Length(nome) do
               if not (nome[i] in CaracterValido) then
               begin
                 RestauraTela(TelaAux);
                 Erro(6, 2, HouveErro);
               end;
             if (nome <> ESC) and (not HouveErro) then
               SalvaMatriz(MatInv, 1, nome, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(' Formatando os elementos da matriz...',
             '                        ');
             Window(11, 14, 69, 20); Cor(2, 7);
             imp.racional := 1;
             ClrScr;
             MostraMatriz(MatInv, imp);
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(mens2[1, 2]);
             SalvaTela(TelaAux);
           end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      F7 : voltar := true;
      F8 : begin
             mat := MatInv;
             for i :=  0 to 11 do
             begin
               ja.calc[i] := false;
               ja.imprimiu[i] := false;
             end;
             voltar := true;
             trocou := true;
           end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura :=  LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[1]) then
               begin
                 Mens(' MATRIZ INVERSA DE M ', imp);
                 Writeln(Lst);
                 MostraMatriz(MatInv, imp);
                 Writeln(Lst);
                 ja.imprimiu[1] := true;
               end;
               imp.tela := 1; imp.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatEsc(var mat: matriz; imp: InfoPress; var sair,
                       trocou: boolean; var ja: MatLogica; var MatEsc: matriz);

var
  tam1, tam2, i: byte;
  HouveErro, voltar: boolean;
  ch: char;
  nome: string[20];
  TelaAux: TelaPtr;

begin
  New(TelaAux); imp.racional := 0;
  voltar := false; trocou := false;
  if (not ja.calc[2]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Escalonando a matriz...                                     ');
    MatEsc := mat;
    EscalonaMatriz(MatEsc, 3);
    GoToXY(1, 1); Write(mens2[2, 2]);
    ja.calc[2] := true;
  end;
  FormataMatriz(MatEsc, tam1, tam2);
  Window(11, 14, 69, 20); Cor(2, 7);
  MostraMatriz(MatEsc, imp);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela(22, 21, ' Nome da matriz? ', nome);
             for i := 1 to Length(nome) do
               if not (nome[i] in CaracterValido) then
               begin
                 RestauraTela(TelaAux);
                 Erro(6, 2, HouveErro);
               end;
             if (nome <> ESC) and (not HouveErro) then
               SalvaMatriz(MatEsc, 1, nome, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(' Formatando os elementos da matriz...',
             '                        ');
             Window(11, 14, 69, 20); Cor(2, 7);
             imp.racional := 1;
             ClrScr;
             MostraMatriz(MatEsc, imp);
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(mens2[2, 2]);
             SalvaTela(TelaAux);
           end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      F7 : voltar := true;
      F8 : begin
             mat := MatEsc;
             for i :=  0 to 11 do
             begin
               ja.calc[i] := false;
               ja.imprimiu[i] := false;
             end;
             voltar := true;
             trocou := true;
           end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura :=  LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[2]) then
               begin
                 Mens(' MATRIZ M ESCALONADA ', imp);
                 Writeln(Lst);
                 MostraMatriz(MatEsc, imp);
                 Writeln(Lst);
                 ja.imprimiu[2] := true;
               end;
               imp.tela := 1; imp.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraAutoval(mat: matriz; var sair: boolean; var ja: MatLogica;
                                    var PolCar: polinomio; var w: autovalores);

var
  ch: char;
  HouveErro, voltar: boolean;
  op: InfoPress;
  TelaAux: TelaPtr;
  i: byte;
  nome: string[20];

begin
  New(TelaAux); voltar := false;
  op.racional := 0; voltar :=  false;
  op.largura := 56; op.MaxL :=  5;
  op.tela := 1; op.opcao := 1;
  if (not ja.calc[4]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio caracterstico...                    ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[3, 2]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando os autovalores...                                ');
    CalculaAutovalores(PolCar, w);
    GoToXY(1, 1); Write(mens2[3, 2]);
    ja.calc[3] := true;
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  Writeln; if (mat.m <= 3) then Writeln;
  ImprimeAutovalores(w, op);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela2(22, 21, 'Salvando... ');
             SalvaAutovalores(w, mat.m, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             op.racional := 1; ClrScr;
             Writeln; if (mat.m <= 3) then Writeln;
             ImprimeAutovalores(w, op);
             SalvaTela(TelaAux);
           end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      F7 : voltar := true;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[3]) then
               begin
                 Mens(' AUTOVALORES ', op);
                 Writeln(Lst);
                 ImprimeAutovalores(w, op);
                 Writeln(Lst);
                 ja.imprimiu[3] := true;
               end;
               op.tela := 1; op.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraPolCar(mat: matriz; var sair: boolean; var ja: MatLogica;
                                    var PolCar: polinomio; var w: autovalores);

var
  ch, x: char;
  HouveErro, voltar: boolean;
  op: InfoPress;
  TelaAux: TelaPtr;
  min: minimo;
  i: byte;
  nome: string[20];

begin
  New(TelaAux); voltar :=  false;
  op.racional := 0;
  op.largura :=  56; op.MaxL :=  2;
  op.tela := 1; op.opcao := 1;
  if (not ja.calc[4]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio caracterstico...                    ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[4, 2]);
    Window(11, 14, 69, 20); Cor(2, 7);
    ja.calc[4] := true;
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  Writeln;
  ImprimePolinomioCaracteristico(PolCar, 'P', 'x', op);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela2(22, 21, 'Salvando... ');
             SalvaPolCaracteristico(PolCar, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(' Formatando os coeficientes... ',
                                      '                              ');
             Window(11, 14, 69, 20); Cor(2, 7);
             op.racional := 1; ClrScr; Writeln;
             ImprimePolinomioCaracteristico(PolCar, 'P', 'x', op);
             Window(10, 22, 71, 22); Cor(7, 0);
             GoToXY(1, 1); Write(mens2[4, 2]);
             SalvaTela(TelaAux);
           end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      F7 : voltar := true;
      F10 : begin
              if (not ja.calc[3]) then
              begin
                Window(10, 22, 71, 22); Cor(7, 0); GoToXY(1, 1);
                Write(' Fatorando o polinmio caracterstico...   ',
                 '                  ');
                CalculaAutovalores(PolCar, w);
                ja.calc[3] := true;
              end;
              Window(11, 14, 69, 20); Cor(2, 7);
              ClrScr; Writeln;
              ImprimePolinomioMinimo(w, 'P', 'x', min, op);
              Window(10, 22, 71, 22); Cor(7, 0); Write(mens2[4, 2]);
              repeat
                x := ReadKey;
              until (x <> #0);
            end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[4]) then
               begin
                 Mens(' POLINOMIO CARACTERISTICO ', op);
                 Writeln(Lst);
                 ImprimePolinomioCaracteristico(PolCar, 'P', 'x', op);
                 Writeln(Lst);
                 ja.imprimiu[4] := true;
               end;
               op.tela := 1; op.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatPot(var mat: matriz; imp: InfoPress;
                                 var sair, trocou: boolean; var ja: MatLogica);

var
  tam1, tam2, i: byte;
  HouveErro, voltar: boolean;
  ch: char;
  aux: matriz;
  nome, NStr: string[20];
  TelaAux: TelaPtr;

begin
  New(TelaAux); imp.racional := 0;
  Str(imp.n, NStr);
  aux := mat;
  voltar := false;
  ElevaMatriz(aux, imp.n);
  FormataMatriz(aux, tam1, tam2);
  Window(11, 14, 69, 20); Cor(2, 7);
  MostraMatriz(aux, imp);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela(22, 21, ' Nome da matriz? ', nome);
             for i := 1 to Length(nome) do
               if not (nome[i] in CaracterValido) then
               begin
                 RestauraTela(TelaAux);
                 Erro(6, 2, HouveErro);
               end;
             if (nome <> ESC) and (not HouveErro) then
               SalvaMatriz(aux, 1, nome, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(' Formatando os elementos da matriz...',
             '                        ');
             Window(11, 14, 69, 20); Cor(2, 7);
             imp.racional := 1;
             ClrScr;
             MostraMatriz(aux, imp);
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(mens2[5, 2]);
             SalvaTela(TelaAux);
           end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      F7 : voltar := true;
      F8 : begin
             mat := aux;
             for i :=  0 to 11 do
             begin
               ja.calc[i] := false;
               ja.imprimiu[i] := false;
             end;
             voltar := true;
             trocou := true;
           end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[5]) then
               begin
                 Mens(' MATRIZ M ^ ' + NStr, imp);
                 Writeln(Lst);
                 MostraMatriz(aux, imp);
                 Writeln(Lst);
                 ja.imprimiu[5] := true;
               end;
               imp.tela := 1; imp.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatSem(var mat: matriz; imp: InfoPress; tela2, tela3,
                 tela4: TelaPtr; var sair, trocou: boolean; var ja: MatLogica);

var
  tam1, tam2, i: byte;
  HouveErro, voltar, inv: boolean;
  modo, ch: char;
  aux, p: matriz;
  nome: string[20];
  TelaAux: TelaPtr;

begin
  New(TelaAux);
  p.m := mat.m; p.n := mat.n;
  nome := 'Guizinha';
  repeat
    MostraTela(tela3);
    ModoDeEntrada(modo, nome);
  until (nome <> ESC) or (modo <> '2');
  case modo of
    '1' : begin
            MostraTela(tela4);
            LeTeclado(p);
          end;
    '2' : begin
            LeMatrizDisco(p, nome, HouveErro);
            if HouveErro then
            begin
              Erro(2, 2, HouveErro);
              Exit;
            end;
            if (p.m <> mat.m) then
            begin
              Erro(7, 2, HouveErro);
              Exit;
            end;
          end;
    '3' : GeraMatrizAleatoria(p, 3);
  end;
  aux := p;
  InverteMatriz(aux, inv);
  if (not inv) then
  begin
    Erro(10, 2, HouveErro);
    Exit;
  end;
  MultiplicaMatrizes(aux, mat, aux);
  MultiplicaMatrizes(aux, p, aux);
  Moldura(mat, imp, 6, tela2);
  FormataMatriz(aux, tam1, tam2);
  MostraMatriz(aux, imp);
  SalvaTela(TelaAux);
  voltar := false;
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela(22, 21, ' Nome da matriz? ', nome);
             for i := 1 to Length(nome) do
               if not (nome[i] in CaracterValido) then
               begin
                RestauraTela(TelaAux);
                Erro(6, 2, HouveErro);
               end;
             if (nome <> ESC) and (not HouveErro) then
               SalvaMatriz(aux, 1, nome, TelaAux);
           end;
      F3: begin
            voltar := true;
            sair := true;
          end;
      F4: begin
            Window(10, 22, 71, 22); Cor(7, 0);
            Write(' Formatando os elementos da matriz...',
            '                        ');
            Window(11, 14, 69, 20); Cor(2, 7);
            imp.racional := 1;
            Window(11, 14, 69, 20); Cor(2, 7);
            ClrScr;
            MostraMatriz(aux, imp);
            imp.racional := 0;
            Window(10, 22, 71, 22); Cor(7, 0);
            Write(mens2[6, 2]);
            SalvaTela(TelaAux);
          end;
      F5: Termina(27, 16, 7, TelaAux, ind);
      F7: voltar := true;
      F8: begin
            mat := aux;
            for i :=  0 to 11 do
            begin
              ja.calc[i] := false;
              ja.imprimiu[i] := false;
            end;
            voltar := true;
            trocou := true;
          end;
    AltL : Writeln(Lst);
    AltP,
    AltI : begin
             imp.tela := 0; imp.largura := LarguraImpPapel;
             if (not ja.imprimiu[11]) then
             begin
               Mens(' MATRIZ M ', imp);
               Writeln(Lst);
               MostraMatriz(mat, imp);
               Writeln(Lst);
               ja.imprimiu[11] := true;
             end;
             if (not ja.imprimiu[6]) then
             begin
               Mens(' MATRIZ SEMELHANTE A M ', imp);
               Writeln(Lst);
               MostraMatriz(aux, imp);
               Writeln(Lst);
               ja.imprimiu[6] := true;
             end;
             imp.tela := 1; imp.largura := 56;
           end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraPolMin(mat: matriz; var sair: boolean; var ja: MatLogica;
                   var PolCar: polinomio; var w: autovalores; var min: minimo);

var
  x, ch: char;
  HouveErro, diagonalizavel, voltar: boolean;
  op: InfoPress;
  TelaAux: TelaPtr;
  i: byte;

begin
  New(TelaAux); voltar := false;
  op.racional := 0;
  op.largura :=  56; op.MaxL :=  2;
  op.tela := 1; op.opcao := 0;
  if (not ja.calc[4]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio caracterstico...                    ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[7, 2]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando os autovalores...                                ');
    CalculaAutovalores(PolCar, w);
    GoToXY(1, 1); Write(mens2[7, 2]);
    ja.calc[3] := true;
  end;
  if (not ja.calc[7]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio mnimo...                            ');
    PolMinimo(mat, w, min);
    GoToXY(1, 1); Write(mens2[7, 2]);
    ja.calc[7] := true;
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  Writeln;
  ImprimePolinomioMinimo(w, 'm', 'x', min, op);
  diagonalizavel := true;
  for i := 1 to (w.QuantRe + w.QuantComplex) do
    if (min.expo[i]  > 1) then diagonalizavel := false;
  if diagonalizavel then
  begin
    Window(10, 5, 71, 21); Cor(1, 7);
    GoToXY(18, 17); Write(' A MATRIZ  DIAGONALIZAVEL ');
    Window(11, 14, 69, 20); Cor(2, 7);
  end;
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    ch := ReadKey;
    if (ch = #0) then
    begin
      ch := ReadKey;
      case ch of
        F3 : begin
               voltar := true;
               sair := true;
             end;
        F4 : begin
               Window(10, 22, 71, 22); Cor(7, 0);
               Write(' Formatando os autovalores...  ',
                                             '                              ');
               Window(11, 14, 69, 20); Cor(2, 7);
               op.racional := 1; ClrScr; Writeln;
               ImprimePolinomioMinimo(w, 'm', 'x', min, op);
               Window(10, 22, 71, 22); Cor(7, 0);
               GoToXY(1, 1); Write(mens2[7, 2]);
               SalvaTela(TelaAux);
             end;
        F5 : Termina(27, 16, 7, TelaAux, ind);
        F7 : voltar := true;
        AltL : Writeln(Lst);
        AltP,
        AltI : begin
                 op.tela := 0; op.largura := LarguraImpPapel;
                 if (not ja.imprimiu[11]) then
                 begin
                   Mens(' MATRIZ M ', op);
                   Writeln(Lst);
                   MostraMatriz(mat, op);
                   Writeln(Lst);
                   ja.imprimiu[11] := true;
                 end;
                 if (not ja.imprimiu[7]) then
                 begin
                   Mens(' POLINOMIO MINIMO ', op);
                   Writeln(Lst);
                   ImprimePolinomioMinimo(w, 'm', 'x', min, op);
                   Writeln(Lst);
                   ja.imprimiu[7] := true;
                 end;
                 op.tela := 1; op.largura := 56;
               end;
      end;
    end;
    Window(11, 14, 69, 20); Cor(2, 7);
    RestauraTela(TelaAux);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraAutovet(mat: matriz; var sair: boolean;
                 var ja: MatLogica; var PolCar: polinomio; var w: autovalores);

var
  ch: char;
  HouveErro, voltar: boolean;
  op: InfoPress;
  TelaAux: TelaPtr;
  i: byte;
  auto: AutovetorReal;
  nome: string[20];

begin
  New(TelaAux);
  voltar := false;
  op.racional := 0; voltar :=  false;
  op.largura :=  56; op.MaxL :=  5;
  op.tela := 1; op.opcao := 1; op.n := mat.m;
  if (not ja.calc[4]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio caracterstico...                    ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[8, 2]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando os autovalores...                                ');
    CalculaAutovalores(PolCar, w);
    ja.calc[3] := true;
    GoToXY(1, 1); Write(mens2[8, 2]);
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  if (w.QuantRe = 0) then
  begin
    Writeln; Writeln; Writeln;
    Writeln('                NAO EXISTEM AUTOVALORES REAIS ');
    ch := ReadKey;
    Exit;
  end;
  for i := 1 to w.QuantRe do
  begin
    op.ultimo := (i = w.QuantRe);
    CalculaAutovetores(mat, w.AutovalorRe[i].x, auto);
    ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
  end;
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      F4 : begin
             op.racional := 1; ClrScr;
             for i := 1 to w.QuantRe do
             begin
               op.ultimo := (i = w.QuantRe);
               CalculaAutovetores(mat, w.AutovalorRe[i].x, auto);
               ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
             end;
             SalvaTela(TelaAux);
           end;
      F7 : voltar := true;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel; op.MaxL := 25;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[8]) then
               begin
                 Mens(' AUTOVETORES ', op);
                 Writeln(Lst);
                 for i := 1 to w.QuantRe do
                 begin
                   op.ultimo := (i = w.QuantRe);
                   CalculaAutovetores(mat, w.AutovalorRe[i].x, auto);
                   ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
                 end;
                 Writeln(Lst);
                 ja.imprimiu[8] := true;
               end;
               op.tela := 1; op.largura := 56; op.MaxL :=  5;
           end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatJor(var mat: matriz; imp: InfoPress; var sair, trocou:
  boolean;  var ja: MatLogica;  var MatJor: matriz;  var BaseJor: matriz;
  var PolCar: polinomio; var w: autovalores; var min: minimo; var db: DBlocos);

var
  i, tam1, tam2: byte;
  HouveErro, AchouBase, voltar: boolean;
  x, ch: char;
  nome: string[20];
  TelaAux: TelaPtr;


const
  mensagem: string[45] = ' BASE QUE FORNECE A FORMA DE JORDAN DE M ';

begin
  New(TelaAux);  imp.opcao := 1;
  voltar := false; trocou := false;
  if (not ja.calc[4]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio caracterstico...                    ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[9, 2]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando os autovalores...                                ');
    CalculaAutovalores(PolCar, w);
    ja.calc[3] := true;
    GoToXY(1, 1); Write(mens2[9, 2]);
    Window(11, 14, 69, 20); Cor(2, 7);
  end;
  if (not ja.calc[7]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando o polinmio mnimo...                            ');
    PolMinimo(mat, w, min);
    GoToXY(1, 1); Write(mens2[9, 2]);
    ja.calc[7] := true;
  end;
  if (not ja.calc[9]) then
  begin
    Window(10, 22, 71, 22); Cor(7, 0);
    Write(' Calculando a forma de Jordan...                             ');
    CalculaFormaDeJordan(mat, w, min, HouveErro, db);
    if HouveErro then
    begin
      Erro(8, 2, HouveErro);
      Exit;
    end;
    FormataMatrizJordan(db, MatJor, mat.m, w, min);
    GoToXY(1, 1); Write(mens2[9, 2]);
    ja.calc[9] := true;
  end;
  Window(11, 14, 69, 20); Cor(2, 7);
  FormataMatriz(MatJor, tam1, tam2);
  MostraMatriz(MatJor, imp);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela(22, 21, ' Nome da matriz? ', nome);
             for i := 1 to Length(nome) do
               if not (nome[i] in CaracterValido) then
               begin
                 RestauraTela(TelaAux);
                 Erro(6, 2, HouveErro);
               end;
             if (nome <> ESC) and (not HouveErro) then
               SalvaMatriz(MatJor, 1, nome, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(' Formatando os elementos da matriz...',
             '                        ');
             Window(11, 14, 69, 20); Cor(2, 7);
             imp.racional := 1;
             Window(11, 14, 69, 20); Cor(2, 7);
             ClrScr;
             MostraMatriz(MatJor, imp);
             Window(10, 22, 71, 22); Cor(7, 0);
             Write(mens2[9, 2]);
             imp.racional := 0;
             SalvaTela(TelaAux);
          end;
      F5 : Termina(27, 16, 7, TelaAux, ind);
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[9]) then
               begin
                 Mens(' FORMA DE JORDAN DE M ', imp);
                 Writeln(Lst);
                 MostraMatriz(MatJor, imp);
                 Writeln(Lst);
                 ja.imprimiu[9] := true;
               end;
               imp.tela := 1; imp.largura := 56;
             end;
      F10 : begin
              HouveErro := false;
              if (w.QuantComplex > 0) then
              begin
                Erro(9, 2, HouveErro); Exit;
              end;
              if (not ja.calc[10]) then
              begin
                Window(10, 22, 71, 22); Cor(7, 0);
                Write
                (' Calculando a base da forma de Jordan...                     ');
                CalculaBaseFJordan(mat, db, min, BaseJor, AchouBase);
                ja.calc[10] := true;
              end;
              Window(10, 5, 71, 21); Cor(1, 7);
              GoToXY(Trunc((62 - Length(mensagem))/2), 9);
              Write(mensagem);
              Window(11, 14, 69, 20); Cor(2, 7); ClrScr;
              imp.MaxL := 5;
              Writeln; if (BaseJor.m <= 3) then Writeln;
              ImprimeBase(BaseJor, imp);
              Window(10, 22, 71, 22); Cor(7, 0);
              Write(mens2[10, 2]);
              repeat
                x := ReadKey;
              until (x = #0);
              x :=  ReadKey;
              case x of
                F2 : begin
                       Janela(22, 21, ' Nome da matriz? ', nome);
                       for i := 1 to Length(nome) do
                         if not (nome[i] in CaracterValido) then
                         begin
                           RestauraTela(TelaAux);
                           Erro(6, 2, HouveErro);
                         end;
                       if (nome <> ESC) and (not HouveErro) then
                         SalvaMatriz(BaseJor, 1, nome, TelaAux);
                     end;
                F3 : begin
                       voltar := true;
                       sair := true;
                     end;
                F4 : begin
                       imp.racional := 1;
                       Window(11, 14, 69, 20); Cor(2, 7);
                       ClrScr;
                       Writeln; if (BaseJor.m <= 3) then Writeln;
                       ImprimeBase(BaseJor, imp);
                       imp.racional := 0;
                       SalvaTela(TelaAux);
                     end;
                F5 : Termina(27, 16, 7, TelaAux, ind);
                F7 : voltar := true;
                F8 : begin
                       mat := BaseJor;
                       for i :=  0 to 11 do
                       begin
                         ja.calc[i] := false;
                         ja.imprimiu[i] := false;
                       end;
                       voltar := true;
                       trocou := true;
                     end;
                AltL : Writeln(Lst);
                AltP,
                AltI : begin
                         imp.tela := 0; imp.largura := LarguraImpPapel;
                         if (not ja.imprimiu[11]) then
                         begin
                           Mens(' MATRIZ M ', imp);
                           Writeln(Lst);
                           MostraMatriz(mat, imp);
                           Writeln(Lst);
                           ja.imprimiu[11] := true;
                         end;
                         if (not ja.imprimiu[10]) then
                         begin
                           Mens(' BASE DA FORMA DE JORDAN ', imp);
                           Writeln(Lst);
                           MostraMatriz(BaseJor, imp);
                           Writeln(Lst);
                           ja.imprimiu[10] := true;
                         end;
                         imp.tela := 1; imp.largura := 56;
                       end;
              end;
            end;
      F7 : voltar := true;
      F8 : begin
             mat := MatJor;
             for i :=  0 to 11 do
             begin
               ja.calc[i] := false;
               ja.imprimiu[i] :=  false;
             end;
             voltar := true;
             trocou := true;
           end;
    end;
    RestauraTela(TelaAux);
    Window(11, 14, 69, 20); Cor(2, 7);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

{$I JANELAS.INC}

{ --------------------------------------------------------------------------- }

procedure MenuPrincipal(tela1, tela2, tela3, tela4: TelaPtr;
                                        mat: MatPtr; ind1, ind2, ind3: IndPtr);

var
  mensagem, nome: string[50];
  modo, ch, ch2: char;
  n: shortint;
  xpos, ypos, racional, tam1, tam2, tam3, tam4, i, j: byte;
  imp: InfoPress;
  HouveErro, trocou, inv, trocar, sair: boolean;
  cod: integer;
  tela: TelaPtr;
  Ja: MatLogica;
  min: minimo;
  w: autovalores;
  auto: AutovetorReal;
  nulid: byte;
  determinante: real;
  BaseJor, MatJor, MatInv, MatEsc: MatPtr;
  PolCar: polinomio;
  db: DBlocos;

begin
  Move(ind1^, ind, 4000);
  New(MatInv); New(MatEsc); New(tela); New(MatJor); New(BaseJor);
  for i :=  0 to 11 do
  begin
    ja.calc[i] := false;
    ja.imprimiu[i] := false;
  end;
  sair := false; trocou := false;
  imp.racional := 0; imp.largura := 56; imp.tela := 1; imp.opcao := 1;
  PolCar.grau := mat^.m; imp.n := mat^.m;
  MatJor^.m := mat^.m; MatJor^.n := mat^.n;
  FechaCortina(tela1);
  Window(11, 3, 69, 9); Cor(1, 7); ClrScr;
  if (mat^.m <= 5) then
    MostraMatriz(mat^, imp)
  else
  begin
    Writeln; Writeln; Writeln;
    Write('    PRESSIONE [F6] PARA VER A MATRIZ M COLUNA POR COLUNA');
  end;
  SalvaTela(tela);
  repeat
    HouveErro := false;
    if (trocou and (mat^.m <= 5)) then
    begin
      Window(11, 3, 69, 9); Cor(1, 7); ClrScr;
      MostraMatriz(mat^, imp);
      SalvaTela(tela);
      trocou := false;
    end;
    repeat
      ch := ReadKey;
    until ch in [#0, '0'..'9'];
    case ch of

      '0' : begin                    { nulidade/determinante }
              if (mat^.m <= 5) then
              begin
                Moldura(mat^, imp, 0, tela2);
                MostraNulDet(mat^, imp, sair, ja, nulid, determinante);
              end
              else
                MostraNulDelCol(mat^, sair, ja, nulid, determinante, imp);
            end;

      '1' : begin                      { matriz inversa }
              if (mat^.m <= 5) then
              begin
                Moldura(mat^, imp, 1, tela2);
                MostraMatInv(mat^, imp, sair, trocou, ja, MatInv^, inv);
              end
              else
                MostraMatInvCol(mat^, imp, sair, ja, MatInv^, inv);
            end;

      '2' : begin                      { escalonamento }
              if (mat^.m <= 5) then
              begin
                Moldura(mat^, imp, 2, tela2);
                MostraMatEsc(mat^, imp, sair, trocou, ja, MatEsc^);
              end
              else
                MostraMatEscCol(mat^, imp, sair, ja, MatEsc^);
            end;

      '3' : begin                           { autovalores }
              if (mat^.m <= 5) then
              begin
                Moldura(mat^, imp, 3, tela2);
                MostraAutoval(mat^, sair, ja, PolCar, w);
              end
              else
                MostraAutovalCol(mat^, sair, ja, PolCar, w, imp);
            end;

      '4' : begin           { polinmio caracterstico }
              if (mat^.m <= 5) then
              begin
                Moldura(mat^, imp, 4, tela2);
                MostraPolCar(mat^, sair, ja, PolCar, w);
              end
              else
                MostraPolCarCol(mat^, sair, ja, PolCar, w, imp);
            end;
                                           {   n                }
      '5' : begin                          {  M                 }
               Janela(40, 15, ' Valor de n? ', nome);
               Val(nome, n, cod);
               if (cod = 0) then
               begin
                 imp.n := n;
                 if (mat^.m <= 5) then
                 begin
                   Moldura(mat^, imp, 5, tela2);
                   MostraMatPot(mat^, imp, sair, trocou, ja);
                 end
                 else
                   MostraMatPotCol(mat^, imp, sair, ja);
               end;
             end;

                                        {  -1              }
      '6' : begin                       { P  MP            }
              if (mat^.m <= 5) then
                MostraMatSem(mat^, imp, tela2, tela3, tela4, sair, trocou, ja)
              else
                MostraMatSemCol(mat^, imp, tela2, tela3, tela4, sair, ja);
            end;

       '7' : begin        { polinmio mnimo }
              if (mat^.m <= 5) then
              begin
                Moldura(mat^, imp, 7, tela2);
                MostraPolMin(mat^, sair, ja, PolCar, w, min);
              end
              else
                MostraPolMinCol(mat^, sair, ja, PolCar, w, min, imp);
             end;

       '8' : begin        { autovetores reais }
               if (mat^.m <= 5) then
                 begin
                   Moldura(mat^, imp, 8, tela2);
                   MostraAutovet(mat^, sair, ja, PolCar, w);
                 end
                 else
                   MostraAutovetCol(mat^, sair, ja, PolCar, w, imp);
              end;

       '9' : begin        { forma canonica de Jordan }
               if (mat^.m <= 5) then
               begin
                 Moldura(mat^, imp, 9, tela2);
                 MostraMatJor(mat^, imp, sair, trocou, ja, MatJor^,
                                                 BaseJor^, PolCar, w, min, db);
               end
               else
                 MostraMatJorCol(mat^, imp, sair, ja, MatJor^, BaseJor^,
                                                           PolCar, w, min, db);
             end;

        #0 : begin
               ch := ReadKey;
               case ch of
                 F1 : begin
                        Window(11, 22, 69, 22); Cor(7, 0);
                        Write(' Carregando os arquivos de informaoes...',
                                                          '                 ');
                        MostraTelasInfo(tela);
                      end;
                 F2 : begin
                        Janela(33, 21, ' Nome da matriz? ', nome);
                        for i := 1 to Length(nome) do
                          if not (nome[i] in CaracterValido) then
                          begin
                            RestauraTela(tela);
                            Erro(6, 1, HouveErro);
                          end;
                        if (nome <> ESC) and (not HouveErro) then
                          SalvaMatriz(mat^, 2, nome, tela);
                      end;
                 F3 : sair := true;
                 F4 : begin
                        Window(11, 22, 69, 22); Cor(7, 0);
                        Write(' Formatando os elementos da matriz...    ',
                                                          '                 ');
                        imp.racional := 1;
                        if (mat^.m <= 5) then
                        begin
                          Window(11, 3, 69, 9); Cor(1, 7);
                          ClrScr;
                          MostraMatriz(mat^, imp);
                          imp.racional := 0;
                          Window(11, 22, 69, 22); Cor(7, 0);
                          Write(' F1: Inf.  F2: Salva   F3: Nova matriz   ',
                                'F4: Rac.  F5: Fim');
                          SalvaTela(tela);
                        end;
                      end;
               F5 : Termina(27, 14, 7, tela, ind);
               F6 : begin
                      Window(11, 22, 69, 22);
                      Cor(7, 0); ClrScr;
                      if (mat^.m <= 17) then
                        Write(MatMenu[12])
                      else
                        Write(MatMenu[13]);
                      MostraMatriz(mat^, imp);
                      imp.racional := 0;
                    end;
               AltL : Writeln(Lst);
               AltP,
               AltI : begin
                        if (not ja.imprimiu[11]) then
                        begin
                          imp.tela := 0; imp.largura :=  LarguraImpPapel;
                          Mens(' MATRIZ M ', imp);
                          Writeln(Lst);
                          MostraMatriz(mat^, imp);
                          Writeln(Lst);
                          imp.tela := 1; imp.largura := 56;
                          ja.imprimiu[11] := true;
                        end;
                      end;
               AltT : begin
                        for i :=  0 to 11 do
                        begin
                          ja.calc[i] := false;
                          ja.imprimiu[i]  := false;
                        end;
                        MatrizTransposta(mat^);
                        Window(11, 3, 69, 9); Cor(1, 7); ClrScr;
                        if (mat^.m <= 5) then
                          MostraMatriz(mat^, imp)
                        else
                        begin
                          Writeln; Writeln; Writeln;
                          Write('    PRESSIONE [F6] PARA VER A MATRIZ M ',
                                'COLUNA POR COLUNA');
                        end;
                        SalvaTela(tela);
                      end;
             end;
           end;
    end;
    RestauraTela(tela);
  until sair;
  Dispose(BaseJor); Dispose(MatJor); Dispose(MatInv);
  Dispose(MatEsc); Dispose(tela);
end;

{ --------------------------------------------------------------------------- }

var
  arq: file of byte;
  decimais, HaCor: byte;

begin
  Assign(arq, 'ALC.DTA');
  {$I-}
  Reset(arq);
  {$I+}
  if (IOResult = 0) then
  begin
    Read(arq, decimais, HaCor, LarguraImpPapel);
    Close(arq);
  end;
end.

{ =========================================================================== }

