{ =========================================================================== }
{                                 JORDEMO.PAS                                 }
{ =========================================================================== }

{$E+,N+,R+,S+,B-,V-}

{$M 65520, 0, 655200}

program JorDemo;

{ ---> Calcula  a forma canonica de Jordan de uma matriz e a base que fornece
       a respectiva forma                                                     }

uses
  Crt, Equacao, Matrizes, FPTCBas, AlgLin, Printer, Jordan;

var
  aux, base, mat, JorMat: matriz;
  p: polinomio;
  kk, autoval, expo, linha, col, quant, xpos, ypos, tam1, tam2, i, j, k: byte;
  w: autovalores;
  auto: AutovetorReal;
  teste, AchouBase, AchouAltura, HouveErro, falha, invers: boolean;
  op1, op2, op3: string;
  ch, opcao1, opcao2, opcao3: char;
  soma: real;
  min: minimo;
  op: InfoPress;
  tela: TelaPtr;
  h: array[1..MaxM] of byte;
  s: vetor;
  db: DBlocos;

const
  erro = 0.000001;
  mensagem: array[1..23] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  JORDEMO opcao1 opcao2 opcao3             ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  opcao1 = A se a matriz for gerada aleatoriamente    ',
   '                                                                      ',
   '                  opcao1 = D se a matriz for carregada do disco       ',
   '                                                                      ',
   '                  opcao1 = T se a matriz entrar pelo teclado          ',
   '                                                                      ',
   '                  opcao2 = R se o formato dos numeros for real        ',
   '                                                                      ',
   '                  opcao2 = Q se o formato dos numeros for racional    ',
   '                                                                      ',
   '                  opcao3 = T se os resultados forem mostrados na tela ',
   '                                                                      ',
   '                  opcao3 = P se os resultados forem impressos         ',
   '                                                                      ',
   '             Exemplo  JORDEMO T Q T                                  ',
   '                                                                      ',
   '          ');

begin
  op.opcao := 0; op.largura := 79; op.MaxL := 101;
  op1 := ParamStr(1); op2 := ParamStr(2); op3 := ParamStr(3);
  if (ParamCount >= 1) then opcao1 := UpCase(op1[1]) else opcao1 := ' ';
  if (ParamCount >= 2) then opcao2 := UpCase(op2[1]) else opcao2 := ' ';
  if (ParamCount >= 3) then opcao3 := UpCase(op3[1]) else opcao3 := ' ';
  if ((opcao1 <> 'T') and (opcao1 <> 'A') and (opcao1 <> 'D')) then
  begin
    ClrScr; Writeln(#7);
    for i := 1 to 23 do Writeln(mensagem[i]);
    Halt;
  end;
  if (opcao2 = 'Q') then op.racional := 1 else op.racional := 0;
  if (opcao3 = 'P') then op.tela := 0 else op.tela := 1;

  repeat

  ClrScr;
  case opcao1 of
    'T' : begin
            Write('FORNECA A ORDEM E OS ELEMENTOS DA MATRIZ QUADRADA M ');
            Writeln('([Ctrl][Break] para parar)'); Writeln;
            Write('Ordem da matriz (de 2 a ', MaxM,  ') : ');
            Readln(mat.m); mat.n := mat.m;
            LeMatriz(mat, 0);
          end;
    'A' : GeraMatrizAleatoria(mat, 2);
    'D' : LeMatrizDisco(mat, '', HouveErro);
  end;

  ClrScr;
  Mens(' MATRIZ M  ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  MostraMatriz(mat, op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Pressione um G para salvar a matriz ou qualquer tecla para continuar');
  ch := UpCase(ReadKey);
  GoToXY(xpos, ypos); ClrEol;
  if (ch = 'G') then SalvaMatriz(mat, 2, '', tela);
  GoToXY(xpos, ypos); ClrEol;

  Write('Calculando os coeficientes do polinomio caracteristico...');
  PolCaracteristico(mat, p);
  GoToXY(xpos, ypos); ClrEol;
  Write('Calculando os autovalores...');
  CalculaAutovalores(p, w);
  GoToXY(xpos, ypos); ClrEol;
  Write('Calculando o polinomio minimo...');
  PolMinimo(mat, w, min);
  GoToXY(xpos, ypos); ClrEol;
  Write('Calculando a forma de Jordan...');
  CalculaFormaDeJordan(mat, w, min, HouveErro, db);
  FormataMatrizJordan(db, JorMat, mat.m, w, min);
  GoToXY(xpos, ypos); ClrEol;

  Mens(' FORMA DE JORDAN J DE M ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  MostraMatriz(JorMat, op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Calculando a base da forma de Jordan...');
  CalculaBaseFJordan(mat, db, min, base, AchouBase);
  GoToXY(xpos, ypos); ClrEol;
  Mens(' VETORES DA BASE QUE FORNECE A FORMA DE JORDAN ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  MostraMatriz(base, op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY; Writeln('Testando...'); aux := mat;
  MatrizRelBase(mat, base, aux);
  teste := true;
  for i := 1 to mat.m do
    for j := 1 to mat.n do
      if (Abs(aux.a[i, j] - JorMat.a[i, j]) > erro) then teste := false;
  GoToXY(xpos, ypos); ClrEol;
  if teste then
    if (op.tela = 1) then
      Writeln('*** BASE TESTADA  ***')
    else
      Writeln(Lst, '*** BASE TESTADA ***')
  else
    if (op.tela =  1) then
      Writeln('*** BASE COM ALGUM PROBLEMA ***')
    else
      Writeln(Lst, '*** BASE COM ALGUM PROBLEMA ***');
  Delay(2000); GoToXY(xpos, ypos); ClrEol;
  if (op.tela = 1) then
    Writeln('                                                      -1')
  else
    Writeln(Lst, '                                                      -1');
  Mens(' MATRIZ P DA MUDANCA DE BASE (J = P  MP)  ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  for i := 1 to aux.m do
    for j := 1 to aux.n do
      if (i = j) then aux.a[i, j] := 1 else aux.a[i, j] := 0;
  MatrizMudancaDeBase(aux, base, aux, teste);
  if (not teste) then
    if (op.tela = 1) then
      Writeln('*** BASE COM ALGUM PROBLEMA ***')
    else
      Writeln(Lst, '*** BASE COM ALGUM PROBLEMA ***')
  else
    MostraMatriz(aux, op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  ch := ReadKey;

  until (1 > 2);
end.

{ =========================================================================== }

